/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package balabit;

import balabit.model.MeasurementTwoclassAuthentication;
import balabit.model.ClassifierEnum;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.logging.Level;
import java.util.logging.Logger;
import static balabit.model.ClassifierEnum.IBk;
import static balabit.util.Utils.readSessions;
import java.util.ArrayList;


/**
 * INPUT: user<USERID>_train.arff files
 * OITPUT: results.txt contains userspecific results: userid, Accuracy, AUC
 * 
 * In order to obtain the user-specific results for all types of actions (MM, PC, DD)
 * you have to run MainBalabitTrainSplit for the corresponding training file
 * type1 - MM - Mouse Move
 * type3 - PC - Point Click
 * type4 - DD _Drag and Drop
 * This produces the user specific ARFF files containing only the selected type of actions.
 */

public class MainEvaluation {

    public static int[] userids = {7, 9, 12, 15, 16, 20, 21, 23, 29, 35};
   
    public static void main(String[] args) throws Exception {
        PrintStream results = null;
        try {
            results = new PrintStream("results_type3_DD.txt");
           
        } catch (FileNotFoundException ex) {
            Logger.getLogger(MainEvaluation.class.getName()).log(Level.SEVERE, null, ex);
        }

        results.println("userid, Accuracy, AUC");
        MeasurementTwoclassAuthentication measurement = null;       
        System.out.println("Random Forest");
        measurement = new MeasurementTwoclassAuthentication(results, "RandomForests_scores.txt");
        measurement.createClassifier(ClassifierEnum.RandomForests);
        measurement.evaluateTrainActionCV( 10 ); 
        results.close();
        

    }
}
