package balabit.model;

import balabit.MainEvaluation;
import balabit.model.ClassifierEnum;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.List;
import java.util.Random;
import java.util.Scanner;
import java.util.logging.Level;
import java.util.logging.Logger;

import weka.classifiers.Classifier;
import weka.classifiers.Evaluation;
import weka.classifiers.bayes.BayesNet;
import weka.classifiers.lazy.IBk;
import weka.classifiers.trees.RandomForest;
import weka.core.Attribute;
import weka.core.FastVector;
import weka.core.Instance;
import weka.core.Instances;

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
/**
 *
 * @author manyi
 */
public class MeasurementTwoclassAuthentication {

    private PrintStream results;
    private String scoresFilename;
    private PrintStream scores;

    private Instances traindata, testdata;
    private Classifier classifier;

    //private ArrayList<Classifier> binaryClassifiers = new ArrayList<>();
    public MeasurementTwoclassAuthentication(PrintStream results, String scoresFilename) {
        this.scoresFilename = scoresFilename;
        this.results = results;

    }

    public void evaluateTrainActionCV(int numFolds) {
        for (int i = 0; i < MainEvaluation.userids.length; ++i) {
            // read train data
            String trainfilename = "user" + MainEvaluation.userids[i] + "_train.arff";
            System.out.println(trainfilename);
            BufferedReader reader = null;
            try {
                reader = new BufferedReader(new FileReader(trainfilename));
                traindata = new Instances(reader);
                traindata.setClassIndex(traindata.numAttributes() - 1);
            } catch (Exception e) {
                e.printStackTrace();
            }

            // evaluate test data
            Evaluation eval = null;
            try {
                classifier.buildClassifier(traindata);
                eval = new Evaluation(traindata);
                eval.crossValidateModel(classifier, traindata, numFolds, new Random(0));
                results.printf("%d, %8.5f, %8.5f\n", MainEvaluation.userids[i], ((double) eval.correct() / traindata.numInstances()) * 100, eval.areaUnderROC(1));
             

            } catch (Exception ex) {
                Logger.getLogger(MeasurementTwoclassAuthentication.class.getName()).log(Level.SEVERE, null, ex);
            }

        }
        if (scores != null) {
            scores.close();
        }
    }
    
     private void createScoresfile() {
        try {
            scores = new PrintStream(scoresFilename);
        } catch (FileNotFoundException ex) {
            Logger.getLogger(MeasurementTwoclassAuthentication.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public void createClassifier(ClassifierEnum param) {
        switch (param) {
            case RandomForests:
                RandomForest classif = new RandomForest();
                classif.setNumTrees(100);
                classifier = classif;
                break;
            case BayesNet:
                classifier = new BayesNet();
                break;
            case IBk:
                classifier = new IBk();
                break;
        }
    }

    
}
